/*
 * MayorAUnaEdadDependienteDep.java
 *
 * Created on 24 de marzo de 2007, 09:53 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Julian
 */
public class MayorAUnaEdadDependienteDep extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	/** Creates a new instance of CampoLlenoParaUnValorDiferenteDeOtroCampo */

	public MayorAUnaEdadDependienteDep() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (codigoNovedad.equals((String) getParams()[1])) {
			if (registro[new Integer((String) getParams()[2]).intValue()]
					.equals(getParams()[3])) {
				String fechaNacimiento = registro[new Integer(
						(String) getParams()[4]).intValue()];

				if (!ValidarFecha.esFecha(fechaNacimiento))
					return false;

				Date dtFechaNacimiento;

				try {
					dtFechaNacimiento = sdf.parse(fechaNacimiento);
				} catch (Exception e) {
					return false;
				}

				long edadDias = ObtenerDiasEntreFechas.calcular(
						dtFechaNacimiento, Calendar.getInstance().getTime());
				;
				long annos = edadDias / 365;

				if (annos > new Integer((String) getParams()[5]).longValue()
						&& !field.equals(getParams()[6])) {

					return true;

				}

			}
		}
		return false;
	}

}